/* XPLog -- an PPP-Dialer and Phonecost Program
 * Copyright (C) 1998 Stefan Kraus
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */ 
 
#include "xplog.h"

/* HomeDirectory */
extern char *user;
extern char xpuser[1024];

extern int a;
extern char APuffer[256];

/* Viewer */
void ratesinfo(void)
{
  struct xplRatesInfo xplRI;

  /* Loop Integer */
  int aa,bb;
  /* Costs Data */
  float geb;
  /* String Data Pointer */
  const char *strdef;

  char BPuffer[1024];

  /* Entrys */
  int enta,entb;
  float entry[350];

  /* Color Definition */
  int cola,colb;
  float cota[192],cotb[192];
  int colt[192];

  xplRI.form = fl_bgn_form(FL_UP_BOX,764,534); 

   fl_set_border_width(2);

   /* Browser 334 */
   xplRI.viewfield = fl_add_frame(FL_DOWN_FRAME,10,10,744,514,"");

   /* Weekday Bar */
   xplRI.QPLbar[1] = fl_add_box(FL_DOWN_FRAME,12,12,50,30,_xpl_riday1);
   xplRI.QPLbar[2] = fl_add_box(FL_DOWN_FRAME,62,12,50,30,_xpl_riday2);
   xplRI.QPLbar[3] = fl_add_box(FL_DOWN_FRAME,112,12,50,30,_xpl_riday3);
   xplRI.QPLbar[4] = fl_add_box(FL_DOWN_FRAME,162,12,50,30,_xpl_riday4);
   xplRI.QPLbar[5] = fl_add_box(FL_DOWN_FRAME,212,12,50,30,_xpl_riday5);
   xplRI.QPLbar[6] = fl_add_box(FL_DOWN_FRAME,262,12,50,30,_xpl_riday6);
   xplRI.QPLbar[7] = fl_add_box(FL_DOWN_FRAME,312,12,50,30,_xpl_riday7);

   xplRI.QPLexit = fl_add_button(FL_NORMAL_BUTTON,364,12,36,28,_xpl_exit);
   fl_set_object_lstyle(xplRI.QPLexit,FL_BOLD_STYLE);

   xplRI.QPLbar[8] = fl_add_box(FL_DOWN_FRAME,402,12,50,30,_xpl_riday8);
   xplRI.QPLbar[9] = fl_add_box(FL_DOWN_FRAME,452,12,50,30,_xpl_riday9);
   xplRI.QPLbar[10] = fl_add_box(FL_DOWN_FRAME,502,12,50,30,_xpl_riday10);
   xplRI.QPLbar[11] = fl_add_box(FL_DOWN_FRAME,552,12,50,30,_xpl_riday11);
   xplRI.QPLbar[12] = fl_add_box(FL_DOWN_FRAME,602,12,50,30,_xpl_riday12);
   xplRI.QPLbar[13] = fl_add_box(FL_DOWN_FRAME,652,12,50,30,_xpl_riday13);
   xplRI.QPLbar[14] = fl_add_box(FL_DOWN_FRAME,702,12,50,30,_xpl_riday14);

   /* Time Bar */
   xplRI.QPLTime[1] = fl_add_box(FL_DOWN_FRAME,362,42,40,20,"00:00");
   xplRI.QPLTime[2] = fl_add_box(FL_DOWN_FRAME,362,62,40,20,"01:00");
   xplRI.QPLTime[3] = fl_add_box(FL_DOWN_FRAME,362,82,40,20,"02:00");
   xplRI.QPLTime[4] = fl_add_box(FL_DOWN_FRAME,362,102,40,20,"03:00");
   xplRI.QPLTime[5] = fl_add_box(FL_DOWN_FRAME,362,122,40,20,"04:00");
   xplRI.QPLTime[6] = fl_add_box(FL_DOWN_FRAME,362,142,40,20,"05:00");
   xplRI.QPLTime[7] = fl_add_box(FL_DOWN_FRAME,362,162,40,20,"06:00");
   xplRI.QPLTime[8] = fl_add_box(FL_DOWN_FRAME,362,182,40,20,"07:00");
   xplRI.QPLTime[9] = fl_add_box(FL_DOWN_FRAME,362,202,40,20,"08:00");
   xplRI.QPLTime[10] = fl_add_box(FL_DOWN_FRAME,362,222,40,20,"09:00");
   xplRI.QPLTime[11] = fl_add_box(FL_DOWN_FRAME,362,242,40,20,"10:00");
   xplRI.QPLTime[12] = fl_add_box(FL_DOWN_FRAME,362,262,40,20,"11:00");
   xplRI.QPLTime[13] = fl_add_box(FL_DOWN_FRAME,362,282,40,20,"12:00");
   xplRI.QPLTime[14] = fl_add_box(FL_DOWN_FRAME,362,302,40,20,"13:00");
   xplRI.QPLTime[15] = fl_add_box(FL_DOWN_FRAME,362,322,40,20,"14:00");
   xplRI.QPLTime[16] = fl_add_box(FL_DOWN_FRAME,362,342,40,20,"15:00");
   xplRI.QPLTime[17] = fl_add_box(FL_DOWN_FRAME,362,362,40,20,"16:00");
   xplRI.QPLTime[18] = fl_add_box(FL_DOWN_FRAME,362,382,40,20,"17:00");
   xplRI.QPLTime[19] = fl_add_box(FL_DOWN_FRAME,362,402,40,20,"18:00");
   xplRI.QPLTime[20] = fl_add_box(FL_DOWN_FRAME,362,422,40,20,"19:00");
   xplRI.QPLTime[21] = fl_add_box(FL_DOWN_FRAME,362,442,40,20,"20:00");
   xplRI.QPLTime[22] = fl_add_box(FL_DOWN_FRAME,362,462,40,20,"21:00");
   xplRI.QPLTime[23] = fl_add_box(FL_DOWN_FRAME,362,482,40,20,"22:00");
   xplRI.QPLTime[24] = fl_add_box(FL_DOWN_FRAME,362,502,40,20,"23:00");

   /* Info Calculation */
   enta=1;
   entb=169;
   for (aa=0 ; aa<=23 ; aa++)
     {
       /* Su A */
       geb = wdaycalc(0,aa,0,0,aa,30,00);
       entry[enta]=geb;
       enta++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLsua[aa+1] = fl_add_box(FL_DOWN_FRAME,12,42+(aa*20),50,20,BPuffer);
       /* Mo A */
       geb = wdaycalc(1,aa,0,0,aa,30,00);
       entry[enta]=geb;
       enta++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLmoa[aa+1] = fl_add_box(FL_DOWN_FRAME,62,42+(aa*20),50,20,BPuffer);
       /* Tu A */
       geb = wdaycalc(2,aa,0,0,aa,30,00);
       entry[enta]=geb;
       enta++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLtua[aa+1] = fl_add_box(FL_DOWN_FRAME,112,42+(aa*20),50,20,BPuffer);
       /* We A */
       geb = wdaycalc(3,aa,0,0,aa,30,00);
       entry[enta]=geb;
       enta++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLwea[aa+1] = fl_add_box(FL_DOWN_FRAME,162,42+(aa*20),50,20,BPuffer);
       /* Th A */
       geb = wdaycalc(4,aa,0,0,aa,30,00);
       entry[enta]=geb;
       enta++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLtha[aa+1] = fl_add_box(FL_DOWN_FRAME,212,42+(aa*20),50,20,BPuffer);
       /* Fr A */
       geb = wdaycalc(5,aa,0,0,aa,30,00);
       entry[enta]=geb;
       enta++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLfra[aa+1] = fl_add_box(FL_DOWN_FRAME,262,42+(aa*20),50,20,BPuffer);
       /* Sa A */
       geb = wdaycalc(6,aa,0,0,aa,30,00);
       entry[enta]=geb;
       enta++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLsaa[aa+1] = fl_add_box(FL_DOWN_FRAME,312,42+(aa*20),50,20,BPuffer);
       /* Su B */
       geb = wdaycalc(0,aa,0,0,aa,60,00);
       entry[entb]=geb;
       entb++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLsub[aa+1] = fl_add_box(FL_DOWN_FRAME,402,42+(aa*20),50,20,BPuffer);
       /* Mo B */
       geb = wdaycalc(1,aa,0,0,aa,60,00);
       entry[entb]=geb;
       entb++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLmob[aa+1] = fl_add_box(FL_DOWN_FRAME,452,42+(aa*20),50,20,BPuffer);
       /* Tu B */
       geb = wdaycalc(2,aa,0,0,aa,60,00);
       entry[entb]=geb;
       entb++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLtub[aa+1] = fl_add_box(FL_DOWN_FRAME,502,42+(aa*20),50,20,BPuffer);
       /* We B */
       geb = wdaycalc(3,aa,0,0,aa,60,00);
       entry[entb]=geb;
       entb++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLweb[aa+1] = fl_add_box(FL_DOWN_FRAME,552,42+(aa*20),50,20,BPuffer);
       /* Th B */
       geb = wdaycalc(4,aa,0,0,aa,60,00);
       entry[entb]=geb;
       entb++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLthb[aa+1] = fl_add_box(FL_DOWN_FRAME,602,42+(aa*20),50,20,BPuffer);
       /* Fr B */
       geb = wdaycalc(5,aa,0,0,aa,60,00);
       entry[entb]=geb;
       entb++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLfrb[aa+1] = fl_add_box(FL_DOWN_FRAME,652,42+(aa*20),50,20,BPuffer);
       /* Sa B */
       geb = wdaycalc(6,aa,0,0,aa,60,00);
       entry[entb]=geb;
       entb++;
       strdef = DoubleStr(geb/100);
       strcpy(BPuffer,strdef);
       xplRI.QPLsab[aa+1] = fl_add_box(FL_DOWN_FRAME,702,42+(aa*20),50,20,BPuffer);
     }

   /* Color Table */
   cola=0;
   for (aa=1 ; aa<=168 ; aa++)
     {
       /* search color */
       xplRI.ready=0;
       if (cola>0)
         {
           for (bb=1 ; bb<=cola ; bb++)
             {
               if (cota[bb]==entry[aa])
                 {
                   xplRI.ready=1;
                 }
             }
         }
       /* new entry */
       if (xplRI.ready==0)
         {
           cola++;
           cota[cola]=entry[aa];
         }
     }
   colb=0;
   for (aa=1 ; aa<=168 ; aa++)
     {
       /* search color */
       xplRI.ready=0;
       if (colb>0)
         {
           for (bb=1 ; bb<=cola ; bb++)
             {
               if (cotb[bb]==entry[aa+168])
                 {
                   xplRI.ready=1;
                 }
             }
         }
       /* new entry */
       if (xplRI.ready==0)
         {
           colb++;
           cotb[colb]=entry[aa+168];
         }
     }
   xplRI.ready=0;

   /* color Tabentrys */
   colt[1]=FL_ORCHID;
   colt[2]=FL_PALEGREEN;
   colt[3]=FL_GREEN;
   colt[4]=FL_BLUE;
   colt[5]=FL_SLATEBLUE;
   colt[6]=FL_WHEAT;;
   colt[7]=FL_TOMATO;
   colt[8]=FL_INDIANRED;
   colt[9]=FL_RED;
   colt[10]=FL_DARKGOLD;
   colt[11]=FL_YELLOW;
   colt[12]=FL_DARKCYAN;
   colt[13]=FL_CYAN;

   /* Set Color */
   enta=1;
   entb=169;
   for (aa=0 ; aa<=23 ; aa++)
     {
       /* Su 30 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[enta]==cota[bb])
             {
               fl_set_object_color(xplRI.QPLsua[aa+1],colt[bb],0);
             } 
         }
       enta++;
       /* Mo 30 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[enta]==cota[bb])
             {
               fl_set_object_color(xplRI.QPLmoa[aa+1],colt[bb],0);
             } 
         }
       enta++;
       /* Tu 30 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[enta]==cota[bb])
             {
               fl_set_object_color(xplRI.QPLtua[aa+1],colt[bb],0);
             } 
         }
       enta++;
       /* We 30 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[enta]==cota[bb])
             {
               fl_set_object_color(xplRI.QPLwea[aa+1],colt[bb],0);
             } 
         }
       enta++;
       /* Th 30 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[enta]==cota[bb])
             {
               fl_set_object_color(xplRI.QPLtha[aa+1],colt[bb],0);
             } 
         }
       enta++;
       /* Fr 30 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[enta]==cota[bb])
             {
               fl_set_object_color(xplRI.QPLfra[aa+1],colt[bb],0);
             } 
         }
       enta++;
       /* Sa 30 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[enta]==cota[bb])
             {
               fl_set_object_color(xplRI.QPLsaa[aa+1],colt[bb],0);
             } 
         }
       enta++;

       /* Su 60 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[entb]==cotb[bb])
             {
               fl_set_object_color(xplRI.QPLsub[aa+1],colt[bb],0);
             } 
         }
       entb++;
       /* Mo 60 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[entb]==cotb[bb])
             {
               fl_set_object_color(xplRI.QPLmob[aa+1],colt[bb],0);
             } 
         }
       entb++;
       /* Tu 60 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[entb]==cotb[bb])
             {
               fl_set_object_color(xplRI.QPLtub[aa+1],colt[bb],0);
             } 
         }
       entb++;
       /* We 60 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[entb]==cotb[bb])
             {
               fl_set_object_color(xplRI.QPLweb[aa+1],colt[bb],0);
             } 
         }
       entb++;
       /* Th 60 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[entb]==cotb[bb])
             {
               fl_set_object_color(xplRI.QPLthb[aa+1],colt[bb],0);
             } 
         }
       entb++;
       /* Fr 60 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[entb]==cotb[bb])
             {
               fl_set_object_color(xplRI.QPLfrb[aa+1],colt[bb],0);
             } 
         }
       entb++;
       /* Sa 60 */
       for (bb=1 ; bb<=cola ; bb++)
         {
           if (entry[entb]==cotb[bb])
             {
               fl_set_object_color(xplRI.QPLsab[aa+1],colt[bb],0);
             } 
         }
       entb++;

     }


  fl_end_form();
      
  fl_show_form(xplRI.form,FL_PLACE_CENTER,FL_TRANSIENT,_xpl_wintitle);
      
  xplRI.ready=0;
  while (xplRI.ready == 0)
    {
      xplRI.obj = fl_do_forms();

      /* Exit */
      if (xplRI.obj == xplRI.QPLexit)
        {
          xplRI.ready=1;      
        }

    }
      
  fl_hide_form(xplRI.form);

  return;

}
